#include <stdio.h> // for fputs, fprintf, stdout, printf, fflush
#include <string.h> // for stdlib

/* 
 * our first program
 */

int main(int argc, char** argv) {
  fputs("Hello, World!\n",stdout); // do some output

  fprintf(stdout, "Hello, World!\n");

  printf("Hello, World!\n");

  printf("Hell\0, World!\n"); // no reason to do this

  fflush(stdout); // be sure to see everything before we crash

  char * str = "Hello, World!\n";
  //str[7] = 'a'; // CRASH, constant strings put in read-only area

  char * str2 = strdup(str); // see man strdup (new heap object)
  str2[7] = 'a';
  printf("str2 holds: %s",str2);

  str2[35] = 'x'; // MIGHT CRASH
  printf("str2 holds: %s",str2);

  str2[14] = 'y'; // MORE LIKELY TO CRASH (or maybe a \0 "next door")
  printf("str2 holds: %s",str2);

  // okay, must get number and types of arguments right
  printf("name of program: %s, number of args: %d\n", argv[0], argc);

  // this next one is broken and a security hole!
  printf("name of program: ");
  printf(argv[0]); // INSECURE, use puts(argv[0]) or printf("%s",argv[0])
  printf(", number of args:");
  //  printf(argc); // COMPILER WARNING, CRASH: no implicit conversion to strings
  return 0;
}
